> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/zec/vpc-network/havip/associatehavip.md).

# AssociateHaVip

## 1. API Description

This API (AssociateHaVip) is used to associate a HaVip with a ZEC instance.

{% hint style="info" %}
**Binding conditions**

* The instance must have been created successfully and not deleted (that is, it is in a normal status such as running or stopped). Instances that are deploying, failed to be created, or being recycled do not support binding.
* The instance must have at least one network interface (primary or secondary) in the subnet where the HaVip is located.
* A single instance can be bound to up to 5 HaVips.
* The same HaVip and instance pair cannot be bound repeatedly.
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type   | Description                                                                                                                                                                                                                                       |
| -------------- | -------- | ------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| haVipId        | Yes      | String | <p>ID of the high availability virtual IP.</p><p>It can be obtained by calling <a href="/api-reference/zec/vpc-network/havip/describehavips.md">DescribeHaVips</a>.</p>                                                                           |
| instanceId     | Yes      | String | <p>ID of the instance to be bound.</p><p>The network interface of the instance must be in the same subnet as the HaVip.</p><p>It can be obtained by calling <a href="/api-reference/zec/instance/describeinstances.md">DescribeInstances</a>.</p> |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Associate a HaVip with the primary instance.**

```json
POST /api/v2/zec HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: AssociateHaVip
<Common Request Params>

Request：
{
  "haVipId": "havip-xxxxxxxx",
  "instanceId": "vm-xxxxxxxx"
}

Response：
{
  "requestId": "T12345678-0000-0000-0000-000000000006",
  "response": {
    "requestId": "T12345678-0000-0000-0000-000000000006"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code                                        | Description                                                        |
| ---------------- | ------------------------------------------------- | ------------------------------------------------------------------ |
| 404              | INVALID\_HAVIP\_NOT\_FOUND                        | The specified HaVip does not exist.                                |
| 404              | INVALID\_INSTANCE\_NOT\_FOUND                     | Instance not found.                                                |
| 400              | OPERATION\_DENIED\_INSTANCE\_STATUS\_NOT\_SUPPORT | Current instance state does not allow this operation.              |
| 400              | INVALID\_INSTANCE\_SUBNET\_NOT\_MATCH             | The specified instance has no NIC in the same subnet as the HaVip. |
